foreach name [array names env STOOOP*] {unset env($name)}                                ;# reset any existing environment variables
set env(STOOOPCHECKOBJECTS) 1
source stooop.tcl
namespace import stooop::*

### basic objects checking

# expected output:
## stooop::record invoked from main script
## stooop::report invoked from main script:
## + ::a(1) created in main script
## stooop::report invoked from main script:
## + ::a(1) created in main script
## + ::a(2) created in ::p
## stooop::report invoked from main script:
## + ::a(1) created in main script
## + ::a(2) created in ::p
## + ::a(3) created in ::n::p
## stooop::record invoked from main script
## stooop::report invoked from main script:
## - ::a(1) created in main script
## stooop::report invoked from main script:
## - ::a(1) created in main script
## - ::a(2) created in ::p
## stooop::report invoked from main script:
## - ::a(1) created in main script
## - ::a(2) created in ::p
## - ::a(3) created in ::n::p
## stooop::record invoked from main script
## stooop::report invoked from main script:
## + ::A(4) created in main script
## stooop::report invoked from main script:
## + ::A(4) created in main script
## + ::A(5) created in ::q
## stooop::report invoked from main script:
## + ::A(4) created in main script
## + ::A(5) created in ::q
## + ::A(6) created in ::m::q
## stooop::record invoked from main script
## stooop::report invoked from main script:
## - ::A(4) created in main script
## stooop::report invoked from main script:
## - ::A(4) created in main script
## - ::A(5) created in ::q
## stooop::report invoked from main script:
## - ::A(4) created in main script
## - ::A(5) created in ::q
## - ::A(6) created in ::m::q

class a {}
proc a::a {this} {}
proc a::~a {this} {}
proc p {} {
    new a
}
namespace eval n {
    proc p {} {
        new a
    }
}
stooop::record
new a
stooop::report
p
stooop::report
n::p
stooop::report
stooop::record
delete 1
stooop::report
delete 2
stooop::report
delete 3
stooop::report

class A {
    proc A {this} {}
    proc ~A {this} {}
}
proc q {} {
    new A
}
namespace eval m {
    proc q {} {
        new A
    }
}
stooop::record
new A
stooop::report
q
stooop::report
m::q
stooop::report
stooop::record
delete 4
stooop::report
delete 5
stooop::report
delete 6
stooop::report
